﻿/********************************************************
JavaScript for Illustrator CS6 ( Win / Mac )

■■テキストばらし■■

複数行のテキストを改行で別オブジェクトに分割します。

作成者：倉田タカシ                             2007_05_01
********************************************************/

/********************************************************
各行を複製して書式をもとのまま反映する仕様に変更しました。

改変：藤田徳朗（タクトシステム株式会社）　2016_03_17
********************************************************/

#target illustrator

var itemsToSplit = new Array() ;	//各テキストを格納
var HorV ;  // 縦か横か
var txPos ; // 位置

// 選択オブジェクト
selectedObj = app.activeDocument.selection ;
// 何も選択していなければ
if( selectedObj.length == 0 )
{
	alert("まず、改行で分割したいテキストを選択してください。  ( Select texts first. )");
}
else
{
    // 選択したオブジェクトについて
    for( i=0; i<selectedObj.length; i++ )
    {
        // 選択したオブジェクトがテキストフレームかどうか
        if (selectedObj[i] != undefined){
            if( selectedObj[i].typename == "TextFrame" ) {
                // 配列itemsToSplitにオブジェクトごと入れる
                itemsToSplit.push(selectedObj[i])
            }
        }
    }
}

// 選択オブジェクトのテキストフレームについて
for( i=0; i<itemsToSplit.length; i++ ) {
    
    var preLeading = 0
    var HorV = ( itemsToSplit[i].orientation == TextOrientation.HORIZONTAL ) ;
    var txPos = itemsToSplit[i].position ;
    var posX = txPos[0] ;
    var posY = txPos[1] ;

    // 改行ごとに分割処理をする
    for( j=0; j<itemsToSplit[i].paragraphs.length; j++ ) {

    // 文字列
    try {
        var str = itemsToSplit[i].paragraphs[j].contents ;
    } catch (e) {
        var str = "" ;
    }

    // 文字送り
    try {
        var pleading = itemsToSplit[i].paragraphs[j-1].leading ;
    } catch (e) {
        var pleading = preLeading ;
    }

    // 縦か横か：trueなら横
    if( HorV ) {
        posY = posY - pleading ;
    } else {
        posX = posX - pleading ;
    }

    // 文字列が空でなければ
    if (str != "") {
        // 複製する
        itemsToDuplicate = itemsToSplit[i].duplicate() ;
        // 位置を移動する
        itemsToDuplicate.position = [posX, posY] ;
        // 空の文字列を入れる
        itemsToDuplicate.contents = "" ;
        // 段落を複製
        itemsToSplit[i].paragraphs[j].duplicate(itemsToDuplicate);
    }
    var preLeading = pleading ;
    }
    itemsToSplit[i].remove() ;
}